%
% Han-Sun-Han-SAMPAJO 2005 function test
%
% what = 'f'  compute the Rosenbrock function
% what = 'Df' compute the Gradient of the Rosenbrock function
% what = 'DDf' compute the Hessian of the Rosenbrock function
%
function RES = Han( what, XIN )

  if nargin > 1
    x = XIN(1,:) ;
    y = XIN(2,:) ;
  end

  switch what
  case 'name'
    RES = 'Han-Sun-Han-SAMPAJO' ;
  case 'init'
    RES = [ 5 ; 3 ] ;
  case 'f'
    RES = x .^ 8 + x .^ 2 + x .^ 2 .* y .^ 2 + exp(y .^ 2);
  case {'F','Df'}
    t1 = x .^ 2;
    t3 = t1 .^ 2;
    t7 = y .^ 2;
    t12 = exp(t7);
    RES = [ (8 * t3 .* t1 .* x) + (2 .* x) + 2 * x .* t7 ; ...
            (2 * t1 .* y) + 2 * y .* t12] ;
  case {'JF','DDf'}
    t1  = (x ^ 2);
    t2  = (t1 ^ 2);
    t5  = y ^ 2;
    t9  = 4 * x * y;
    t11 = exp(t5);
    RES = [ (56 * t2 .* t1) + 2 + 2 * t5,  t9 ; ...
            t9, (2 * t1) + 2 * t11 + 4 * t5 .* t11] ;
  otherwise
    error(['Han bad argument:' what]) ;
  end ;
end