%
% Powell Badly Scaled test
%
% what = 'f'  compute the Rosenbrock function
% what = 'Df' compute the Gradient of the Rosenbrock function
% what = 'DDf' compute the Hessian of the Rosenbrock function
%
function RES = PowellBadlyScaled( what, X )
  
  if nargin > 1
    x1 = X(1,:) ;
    x2 = X(2,:) ;
  end

  switch what
  case 'name'
    RES = 'Powell Badly Scaled' ;
  case 'init'
    RES = [0;100] ;
  case 'F'
    RES = [10000 * x1 * x2 - 1 ; exp(-x1) + exp(-x2) - 0.10001e1];
  case 'JF'
    RES = [10000 * x2, 10000 * x1; -exp(-x1), -exp(-x2)];
  case 'f'
    RES = ((10000 .* x1 .* x2 - 1) .^ 2) + (exp(-x1) + exp(-x2) - 0.10001e1) .^ 2 ;
  case 'Df'
    t3  = 10000 * x1 * x2 - 1;
    t6  = exp(-x1);
    t7  = exp(-x2);
    t8  = t6 + t7 - 0.10001e1;
    RES = [ (20000 * t3 * x2) - 0.2e1 * t8 * t6; (20000 * t3 * x1) - 0.2e1 * t8 * t7 ] ;
  case 'DDf'
    t1 = (x2 ^ 2);
    t3 = exp(-x1);
    t4 = t3 ^ 2;
    t6 = exp(-x2);
    t7 = t3 + t6 - 0.10001e1;
    t15 = 0.400000000e9 * x1 * x2 - 0.20000e5 + 0.2e1 * t6 * t3;
    t16 = x1 ^ 2;
    t18 = t6 ^ 2;
    RES = [ (200000000 * t1) + 0.2e1 * t4 + 0.2e1 * t7 * t3, t15; ...
            t15, 0.200000000e9 * t16 + 0.2e1 * t18 + 0.2e1 * t7 * t6 ] ;
  otherwise
    error(['Wood bad argument:' what]) ;
  end ;
end