%
% Rosenbrock test
%
% what = 'f'  compute the Rosenbrock function
% what = 'Df' compute the Gradient of the Rosenbrock function
% what = 'DDf' compute the Hessian of the Rosenbrock function
%
function RES = Rosenbrock( what, XIN )

  if nargin > 1
    X  = XIN(1,:) ;
    Y  = XIN(2,:) ;
    YX = Y - X.^2 ;
  end

  switch what
  case 'name'
    RES = 'Rosenbrock' ;
  case 'init'
    RES = [ -1.2 ; 1 ] ;
  case 'f'
    RES = 100*YX.^2+(X-1).^2 ;
  case {'F','Df'}
    RES = [ 2*(X-1) - 400*YX.*X ; 200*YX ] ;
  case {'JF','DDf'}
    RES = [ 1200 * X.^2 - 400 *Y + 2, -400*X ; ...
            -400*X,                    200*ones(size(X)) ] ;
  otherwise
    error(['Rosenbrock bad argument:' what]) ;
  end ;
end